#pragma once

#include "cuda_check.cuh"

class CudaVector
{
public:
  CudaVector(size_t n) : _n(n), _bytes(_n*sizeof(double))
  {
    CUDA_CHECK_OP(cudaMalloc(&_data, _bytes));
  }
  ~CudaVector()
  {
    cudaFree(_data);
  }
  size_t n() const { return _n; }
  double * data() { return _data; }
  const double * data() const { return _data; }
  size_t bytes() const { return _bytes; }

private:
  double * _data;
  size_t _n;
  size_t _bytes;
};

